# Makefile
# NLTool - FidoNet Nodelist Maintenance Tool

include mkconfig.mk

all:	$(BIN) $(OBJ) $(BD)nlmaint$(E) $(BD)nledit$(E) $(BD)nldiff$(E) $(BD)nlscan$(E)

$(BD)nlmaint$(E):	$(OD)main$(O) $(OD)config$(O) $(OD)nodelist$(O) $(DNLLIB)
	$(LD) $(LDFLAGS) $(LOUT)$(BD)nlmaint$(E) $(OD)main$(O) $(OD)config$(O) $(OD)nodelist$(O) $(LNLLIB)

$(BD)nledit$(E):	$(OD)nledit$(O) $(DNLLIB)
	$(LD) $(LDFLAGS) $(LOUT)$(BD)nledit$(E) $(OD)nledit$(O) $(LNLLIB)

$(BD)nldiff$(E):	$(OD)nldiff$(O) $(DNLLIB)
	$(LD) $(LDFLAGS) $(LOUT)$(BD)nldiff$(E) $(OD)nldiff$(O) $(LNLLIB)

$(BD)nlscan$(E):	$(OD)scanlist$(O) $(DNLLIB)
	$(LD) $(LDFLAGS) $(LOUT)$(BD)nlscan$(E) $(OD)scanlist$(O) $(LNLLIB)

$(DNLLIB): library
	$(MAKE) -f NLlib.mk $(MAKEFLAGS)

library:		# Phony target

clean:
	make -f NLlib.mk clean
	-rm -rf $(BIN)
	-rm -rf *.*~ *.bak mak/*.*~ mak/*.bak $(SD)*.*~ $(SD)*.bak $(HD)*.*~ $(HD)*.bak core

$(BIN):
	-mkdir $@

$(OBJ):
	-mkdir $@

$(OD)main$(O):		$(SD)main.c     $(HD)nlmaint.h $(HD)compress.h $(HD)aplydiff.h $(HD)osdep.h $(HD)parse.h $(HD)log.h $(HD)wfile.h $(HD)crc16.h $(HD)checknl.h $(HD)cfile.h $(HD)strbuf.h $(HD)array.h $(HD)txtbuf.h $(HD)mem.h
	$(COMPILE)

$(OD)nledit$(O):	$(SD)nledit.c   $(HD)nlmaint.h $(HD)compress.h $(HD)aplydiff.h $(HD)osdep.h $(HD)parse.h $(HD)log.h $(HD)wfile.h $(HD)crc16.h $(HD)checknl.h $(HD)cfile.h $(HD)strbuf.h $(HD)array.h $(HD)txtbuf.h $(HD)mem.h
	$(COMPILE)

$(OD)nldiff$(O):	$(SD)nldiff.c   $(HD)nlmaint.h $(HD)compress.h $(HD)aplydiff.h $(HD)osdep.h $(HD)parse.h $(HD)log.h $(HD)wfile.h $(HD)crc16.h $(HD)checknl.h $(HD)cfile.h $(HD)strbuf.h $(HD)array.h $(HD)txtbuf.h $(HD)mem.h
	$(COMPILE)

$(OD)scanlist$(O):	$(SD)scanlist.c $(HD)nlmaint.h $(HD)compress.h $(HD)aplydiff.h $(HD)osdep.h $(HD)parse.h $(HD)log.h $(HD)wfile.h $(HD)crc16.h $(HD)checknl.h $(HD)cfile.h $(HD)strbuf.h $(HD)array.h $(HD)txtbuf.h $(HD)mem.h
	$(COMPILE)

$(OD)config$(O):	$(SD)config.c   $(HD)nlmaint.h $(HD)parse.h $(HD)osdep.h $(HD)wfile.h $(HD)mem.h $(HD)log.h
	$(COMPILE)

$(OD)nodelist$(O):	$(SD)nodelist.c $(HD)nlmaint.h $(HD)compress.h $(HD)aplydiff.h $(HD)osdep.h $(HD)parse.h $(HD)log.h $(HD)wfile.h $(HD)crc16.h $(HD)checknl.h $(HD)cfile.h $(HD)strbuf.h $(HD)array.h $(HD)txtbuf.h $(HD)mem.h
	$(COMPILE)

