include mkconfig.mk

# Override this for library code

SRC=    libsrc

LIBRSP=	nlib.rsp

LIBOBJS=$(OD)mem$(O) $(OD)strbuf$(O) $(OD)fidoaddr$(O) $(OD)log$(O) \
	$(OD)osdep$(O) $(OD)merge$(O) $(OD)checknl$(O) $(OD)aplydiff$(O) \
	$(OD)filediff$(O) $(OD)crc16$(O) $(OD)cmdtpl$(O) $(OD)compress$(O) \
	$(OD)parse$(O) $(OD)wfile$(O) $(OD)cfile$(O) $(OD)txtbuf$(O) \
	$(OD)array$(O) $(OD)harray$(O) $(OD)hmem$(O)

all:	$(OBJ) $(LIB) $(DNLLIB)

$(DNLLIB):	$(LIBOBJS) updrsp$(E) $(OBJ) $(LIB)
	$(RM) $(LIBRSP)
	updrsp $(LIBRSP) -L $(LIBOBJS)
	$(AR) $(ARFLAGS) $@ @$(LIBRSP)
#	$(AR) $(ARFLAGS) $@ `cat nlib.rsp`
#	$(RL) $@

updrsp$(E):
	$(LD) $(CFLAGS) $(LDFLAGS) $(LOUT)$@ src$(DSEP)updrsp.c

updrsp$(O):	src$(DSEP)updrsp.c

clean:
	-rm -rf $(OBJ)
	-rm -rf *.*~ *.bak mak/*.*~ mak/*.bak $(SD)*.*~ $(SD)*.bak $(HD)*.*~ $(HD)*.bak core

$(OBJ):
	-mkdir $@

$(LIB):
	-mkdir $@


$(OD)mem$(O):		$(SD)mem.c	    $(HD)mem.h $(HD)log.h
	$(COMPILE)

$(OD)strbuf$(O):	$(SD)strbuf.c   $(HD)strbuf.h $(HD)mem.h
	$(COMPILE)

$(OD)fidoaddr$(O):	$(SD)fidoaddr.c $(HD)fidoaddr.h $(HD)mem.h
	$(COMPILE)

$(OD)log$(O):		$(SD)log.c      $(HD)log.h $(HD)osdep.h
	$(COMPILE)

$(OD)osdep$(O):		$(SD)osdep.c    $(HD)osdep.h $(HD)mem.h $(HD)parse.h
	$(COMPILE)

$(OD)merge$(O):		$(SD)merge.c    $(HD)wfile.h $(HD)fidoaddr.h $(HD)array.h $(HD)cfile.h $(HD)log.h
	$(COMPILE)

$(OD)checknl$(O):	$(SD)checknl.c  $(HD)checknl.h $(HD)strbuf.h $(HD)osdep.h $(HD)fidoaddr.h $(HD)array.h $(HD)txtbuf.h $(HD)mem.h
	$(COMPILE)

$(OD)aplydiff$(O):	$(SD)aplydiff.c $(HD)aplydiff.h $(HD)fidoaddr.h $(HD)mem.h $(HD)log.h $(HD)osdep.h $(HD)crc16.h $(HD)strbuf.h $(HD)array.h
	$(COMPILE)

$(OD)filediff$(O):	$(SD)filediff.c $(HD)filediff.h $(HD)osdep.h $(HD)log.h $(HD)wfile.h
	$(COMPILE)

$(OD)crc16$(O):		$(SD)crc16.c    $(HD)crc16.h
	$(COMPILE)

$(OD)cmdtpl$(O):	$(SD)cmdtpl.c   $(HD)cmdtpl.h $(HD)osdep.h $(HD)log.h $(HD)mem.h
	$(COMPILE)

$(OD)compress$(O):	$(SD)compress.c $(HD)compress.h $(HD)cmdtpl.h $(HD)parse.h $(HD)osdep.h $(HD)mem.h $(HD)strbuf.h $(HD)array.h
	$(COMPILE)

$(OD)parse$(O):		$(SD)parse.c    $(HD)parse.h
	$(COMPILE)

$(OD)wfile$(O):		$(SD)wfile.c    $(HD)wfile.h $(HD)osdep.h $(HD)mem.h $(HD)log.h
	$(COMPILE)

$(OD)cfile$(O):		$(SD)cfile.c    $(HD)cfile.h $(HD)mem.h $(HD)crc16.h
	$(COMPILE)

$(OD)txtbuf$(O):	$(SD)txtbuf.c   $(HD)txtbuf.h $(HD)mem.h
	$(COMPILE)

$(OD)array$(O):		$(SD)array.c    $(HD)array.h $(HD)mem.h
	$(COMPILE)

$(OD)harray$(O):	$(SD)harray.c   $(HD)array.h $(HD)mem.h
	$(COMPILE)

$(OD)hmem$(O):		$(SD)hmem.c     $(HD)mem.h $(HD)log.h
	$(COMPILE)

