
#ifndef _log_h
#define _log_h

enum _loglevels
{
  LOG_PROGRESS,                        /* Just progress information */
  LOG_MARK,                            /* More interesting progress */
  LOG_EVENT,                            /* Logs a significant event */
  LOG_RESULT,                                 /* Reporting a result */
  LOG_TRANX,                           /* Transaction (mail?) event */
  LOG_WARN,                                              /* Warning */
  LOG_ERROR,                                               /* Error */
  LOG_FATAL,                                         /* Fatal error */
  LOG_NOECHO = 0x8000
};

enum _errorlevels
{
  EL_PROCESSOK      =0,       /* Process mode - no errors */
  EL_PROCESSERRORS  =1,       /* Process mode - no fatal errors */
  EL_PROCESSFATAL   =2,       /* Process mode - fatal error */
  EL_TESTOK         =3,       /* Test mode - no errors */
  EL_TESTERRORS     =4,       /* Test mode - no fatal errors */
  EL_TESTFATAL      =5,       /* Test mode - fatal error */
  EL_INTERNAL       =251,     /* Aborted - Unexpected internal error */
  EL_MEMERROR       =252,     /* Aborted - Memory related error */
  EL_CMDERROR       =253,     /* Aborted - Cmdline error */
  EL_IOERROR        =254,     /* Aborted - I/O error */
  EL_CTLERROR       =255      /* Aborted - control file error */
};

extern  void openlog(char const * logfile, int fmt, int minlevel);
extern  void logit(int loglevel, char const * msg, ...);
extern  void logent(int loglevel, char const * str);
extern  void fatal(int errlvl, char const * msg, ...);
extern  void setlogformat(int fmt);

#endif

